//**********************************************************
// Created by Jonas Skold
// www.jonasskold.se
// jonas@jonasskold.se
//**********************************************************

//********************** Setting variables **************************

//page
var d = document;
var pageBox = d.getElementById("pagebox");//the box where all the pages of stopwatches are
var display = d.getElementById("display");//the box where the time is shown
var startButton = d.getElementById("startButton");//contains a name (e.g. startbutton1) used as the id of the startbutton
var stopButton = d.getElementById("stopButton");//like startbutton and lapbutton

//time
var startTime;//when the stopwatch started
var timeNow;//unformatted, milliseconds since approximately quite long ago
var startPause;//time when stopwatch was paused
var continueTime;//time when stopwatch is started after a pause
var pause;//the amount of time that the stopwatch has been paused
var totalTime;//the total time of the stopwatch in milliseconds
var time;//the formatted time

//format time
var timems;
var hours;
var minutes;
var seconds;
var deciseconds;
var centiseconds;
var milliseconds;
var formattedtime;
var titleTime;

var displayStorlek = 200;

//other
var started;//has the stopwatch been started?
var running;//is the stopwatch running?
var stopped;//is the stopwatched stopped?
var updateStopwatch;//the intervals


//********************** stopwatch **********************************

function stopwatch(){//calculates time
	timeNow = new Date().getTime();
	totalTime = parseInt(timeNow - startTime - pause);
	time = formatTime(totalTime);
	display.innerHTML = formatTime(totalTime);
	d.title = titleTime + " - Tidtagarur";
}//stopwatch


//********************** set stopwatch ******************************

function setStopwatch(){//resets everything
	if(started == 1){
		clearInterval(updateStopwatch);//stops updating stopwatch
	}
	started = 0;
	running = 0;
	pause = 0;
	stopped = 0;
	totalTime = 0;
	toQuick = 1;
	time = formatTime('0');
	display.innerHTML = time;
	d.title="Tidtagarur";
	startKnapp.src="startknapp.png";
	startKnapp.style.visibility = 'visible'; 
}//setStopwatch


//********************** start, stop, pause, continue ***************

function startStopwatch(){//sets starttime and starts updating
	startTime = new Date().getTime();
	stopwatch();
	updateStopwatch = setInterval('stopwatch()', 1);
	started = 1;
	running = 1;
}//startStopwatch

function stopStopwatch(){
	clearInterval(updateStopwatch);//stops updating stopwatch
	started = 0;
	running = 0;
	stopped = 1;
}//stopStopwatch

function pauseStopwatch(){
	startPause = new Date().getTime();
	clearInterval(updateStopwatch);//stops updating stopwatch
	running = 0;
}//pauseStopwatch

function continueStopwatch(){
	continueTime = new Date().getTime();
	pause = continueTime - startPause + pause;
	stopwatch();
	updateStopwatch = setInterval('stopwatch()', 1);
	running = 1;
}//continueStopwatch


//********************** formatting time ****************************

function formatTime(ms){
	timems = ms;
	hours = parseInt(timems/3600000);
	timems = parseInt(timems%3600000);
	minutes = parseInt(timems/60000);
	timems = parseInt(timems%60000);
	seconds = parseInt(timems/1000);
	milliseconds = parseInt(timems%1000);
	centiseconds = parseInt(milliseconds/100);
	
	if(centiseconds<10){centiseconds="0"+centiseconds;}
	if(milliseconds < 10){milliseconds = "0" + milliseconds ;}
	if(milliseconds < 100){milliseconds = "0" + milliseconds; }
	if(seconds<10){seconds="0"+seconds;}
	if(minutes<10){minutes="0"+minutes;}
	//time = hours+":"+minutes+":"+seconds+"."+centiseconds+milliseconds;
		time = minutes+":"+seconds+"." + milliseconds;
	titleTime= hours+":"+minutes+":"+seconds;
	
	if(milliseconds>400){toQuick = 0;}
	
	
	return time;
}//formattime


//********************** actions when pressing buttons **************




function doStartKnapp(){//if startbutton is pressed

    window.oncontextmenu = function () {  
       return false;  
    }  

	if(stopped == 1){
	
		setStopwatch();
		startStopwatch();
		startKnapp.src="startknapp.png";
	
	}
	else if(started == 0){//stopwatch is not started
	//alert("2");
		startStopwatch();
		startKnapp.src="stoppknapp.png";
	
	}//started==0
	else if(started == 1 && running == 1 && toQuick == 0){//stopwatch is started and running
	
		stopStopwatch();
		startKnapp.style.visibility = 'hidden'; 
	
		
	}//started==1 && running==1
	else if(started == 1 && running == 0){//stopwatch is started but not running

		continueStopwatch();
		startKnapp.src="stoppknapp.png";

		//stopStopwatch();
		//startButton.src="startbutton.png";
		//stopButton.src="resetbutton.png";
		
	}//started==1 && running==0
}//startbutton



function doStopButton(){//if stopbutton is pressed
	if(started == 1 && running == 1){
		stopStopwatch();
		startButton.src="startbutton.png";
		stopButton.src="resetbutton.png";
	}//started && running
	else if(stopped == 1 || (started == 1 && running == 0)){
		setStopwatch();
		startButton.src="startbutton.png";
		stopButton.src="stopgraybutton.png";
	}//stopped
}//stopbutton


function doSomething(e) {
	var rightclick;
	if (!e) var e = window.event;
	if (e.which) rightclick = (e.which == 3);
	else if (e.button) rightclick = (e.button == 2);
	 // true or false
	 doStartKnapp();
}
//**********************  stylechooser  *****************************

function changeStyle(s){
	d.getElementById("stylesheet").href = (s == 0) ? "light.css" : "dark.css";
	d.cookie = "style=" + s + "; path=/";
}

//**********************  shortkeys  ********************************

function keyhit(e){
	var evtobj=window.event? event : e //distinguish between IE's explicit event object (window.event) and Firefox's implicit.
	var code=evtobj.charCode? evtobj.charCode : evtobj.keyCode
	
	//if (code===32){//mellanslag - start
//		doStartKnapp();
//	}else 
if(code===78){//N-knappen - stopp
		doStopButton();
	}
//	window.scrollTo(0,0);
}

function changeSize(x){
	
	if(x == 0){
				
				displayStorlek= displayStorlek * 1.05;
				document.getElementById("display").style.fontSize = displayStorlek+"px";
			
	}else if(x == 1){
			
				displayStorlek= displayStorlek * 0.98;
				document.getElementById("display").style.fontSize = displayStorlek+"px";
		
	
	}
} 
document.onkeydown=keyhit;